diff --git a/app/models/compute_resources/foreman/model/openstack.rb b/app/models/compute_resources/foreman/model/openstack.rb
index 7eba98a59..83a973741 100644
--- a/app/models/compute_resources/foreman/model/openstack.rb
+++ b/app/models/compute_resources/foreman/model/openstack.rb
@@ -83,7 +83,7 @@ module Foreman::Model
     end
 
     def associated_host(vm)
-      Host.my_hosts.where(:ip => [vm.floating_ip_address, vm.private_ip_address]).first
+      Host.authorized(:view_hosts, Host).where(:ip => [vm.floating_ip_address, vm.private_ip_address]).first
     end
 
     def flavor_name(flavor_ref)
diff --git a/app/models/compute_resources/foreman/model/ovirt.rb b/app/models/compute_resources/foreman/model/ovirt.rb
index d83944160..b724d37cb 100644
--- a/app/models/compute_resources/foreman/model/ovirt.rb
+++ b/app/models/compute_resources/foreman/model/ovirt.rb
@@ -207,7 +207,7 @@ module Foreman::Model
     end
 
     def associated_host(vm)
-      Host.my_hosts.where(:mac => vm.mac).first
+      Host.authorized(:view_hosts, Host).where(:mac => vm.mac).first
     end
 
     def provider_friendly_name
diff --git a/app/models/compute_resources/foreman/model/rackspace.rb b/app/models/compute_resources/foreman/model/rackspace.rb
index 98f932931..199b8f21c 100644
--- a/app/models/compute_resources/foreman/model/rackspace.rb
+++ b/app/models/compute_resources/foreman/model/rackspace.rb
@@ -88,7 +88,7 @@ module Foreman::Model
     end
 
     def associated_host(vm)
-      Host.my_hosts.where(:ip => [vm.public_ip_address, vm.private_ip_address]).first
+      Host.authorized(:view_hosts, Host).where(:ip => [vm.public_ip_address, vm.private_ip_address]).first
     end
 
     private
diff --git a/app/models/compute_resources/foreman/model/vmware.rb b/app/models/compute_resources/foreman/model/vmware.rb
index bd4ec9f81..476ebc49e 100644
--- a/app/models/compute_resources/foreman/model/vmware.rb
+++ b/app/models/compute_resources/foreman/model/vmware.rb
@@ -165,7 +165,7 @@ module Foreman::Model
     end
 
     def associated_host(vm)
-      Host.my_hosts.where(:mac => vm.mac).first
+      Host.authorized(:view_hosts, Host).where(:mac => vm.mac).first
     end
 
     def provider_friendly_name
diff --git a/app/models/concerns/audit_extensions.rb b/app/models/concerns/audit_extensions.rb
index b495fcbda..31f7593a5 100644
--- a/app/models/concerns/audit_extensions.rb
+++ b/app/models/concerns/audit_extensions.rb
@@ -29,6 +29,8 @@ module AuditExtensions
 
     before_save :ensure_username, :ensure_audtiable_and_associated_name
     after_validation :fix_auditable_type
+
+    include Authorizable
   end
 
   private
diff --git a/app/models/concerns/authorizable.rb b/app/models/concerns/authorizable.rb
new file mode 100644
index 000000000..a70913e80
--- /dev/null
+++ b/app/models/concerns/authorizable.rb
@@ -0,0 +1,23 @@
+module Authorizable
+  extend ActiveSupport::Concern
+
+  included do
+    # permission can be nil (therefore we use Proc instead of lambda)
+    # same applies for resource class
+    #
+    # e.g.
+    #   FactValue.authorized
+    #   FactValue.authorized(:view_facts)
+    #   Host::Base.authorized(:view_hosts, Host)
+    #
+    scope :authorized, Proc.new { |permission, resource|
+      if User.current.nil?
+        self.where('1=0')
+      elsif User.current.admin?
+        self.scoped
+      else
+        Authorizer.new(User.current).find_collection(resource || self, :permission => permission)
+      end
+    }
+  end
+end
diff --git a/app/models/concerns/hostext/search.rb b/app/models/concerns/hostext/search.rb
index 1dfb6f7bf..f1548405c 100644
--- a/app/models/concerns/hostext/search.rb
+++ b/app/models/concerns/hostext/search.rb
@@ -11,6 +11,8 @@ module Hostext
       scoped_search :on => :ip,            :complete_value => true
       scoped_search :on => :comment,       :complete_value => true
       scoped_search :on => :enabled,       :complete_value => {:true => true, :false => false}, :rename => :'status.enabled'
+      scoped_search :on => :owner_type,    :complete_value => true, :only_explicit => true
+      scoped_search :on => :owner_id,      :complete_value => true, :only_explicit => true
       scoped_search :on => :puppet_status, :offset => 0, :word_size => Report::BIT_NUM*4, :complete_value => {:true => true, :false => false}, :rename => :'status.interesting'
       scoped_search :on => :puppet_status, :offset => Report::METRIC.index("applied"),         :word_size => Report::BIT_NUM, :rename => :'status.applied'
       scoped_search :on => :puppet_status, :offset => Report::METRIC.index("restarted"),       :word_size => Report::BIT_NUM, :rename => :'status.restarted'
@@ -19,12 +21,14 @@ module Hostext
       scoped_search :on => :puppet_status, :offset => Report::METRIC.index("skipped"),         :word_size => Report::BIT_NUM, :rename => :'status.skipped'
       scoped_search :on => :puppet_status, :offset => Report::METRIC.index("pending"),         :word_size => Report::BIT_NUM, :rename => :'status.pending'
 
-      scoped_search :in => :model,       :on => :name,    :complete_value => true, :rename => :model
-      scoped_search :in => :hostgroup,   :on => :name,    :complete_value => true, :rename => :hostgroup
-      scoped_search :in => :hostgroup,   :on => :title,   :complete_value => true, :rename => :hostgroup_fullname
-      scoped_search :in => :hostgroup,   :on => :title,   :complete_value => true, :rename => :hostgroup_title
-      scoped_search :in => :domain,      :on => :name,    :complete_value => true, :rename => :domain
-      scoped_search :in => :environment, :on => :name,    :complete_value => true, :rename => :environment
+      scoped_search :in => :model,       :on => :name,    :complete_value => true,  :rename => :model
+      scoped_search :in => :hostgroup,   :on => :name,    :complete_value => true,  :rename => :hostgroup
+      scoped_search :in => :hostgroup,   :on => :title,   :complete_value => true,  :rename => :hostgroup_fullname
+      scoped_search :in => :hostgroup,   :on => :title,   :complete_value => true,  :rename => :hostgroup_title
+      scoped_search :in => :hostgroup,   :on => :id,      :complete_value => false, :rename => :hostgroup_id, :only_explicit => true
+      scoped_search :in => :domain,      :on => :name,    :complete_value => true,  :rename => :domain
+      scoped_search :in => :domain,      :on => :id,      :complete_value => true,  :rename => :domain_id
+      scoped_search :in => :environment, :on => :name,    :complete_value => true,  :rename => :environment
       scoped_search :in => :architecture, :on => :name,    :complete_value => true, :rename => :architecture
       scoped_search :in => :puppet_proxy, :on => :name,    :complete_value => true, :rename => :puppetmaster
       scoped_search :in => :puppet_ca_proxy, :on => :name,    :complete_value => true, :rename => :puppet_ca
@@ -73,7 +77,7 @@ module Hostext
 
       def search_by_puppetclass(key, operator, value)
         conditions  = sanitize_sql_for_conditions(["puppetclasses.name #{operator} ?", value_to_sql(operator, value)])
-        hosts       = Host.my_hosts.all(:conditions => conditions, :joins => :puppetclasses, :select => 'DISTINCT hosts.id').map(&:id)
+        hosts       = Host.authorized(:view_hosts, Host).all(:conditions => conditions, :joins => :puppetclasses, :select => 'DISTINCT hosts.id').map(&:id)
         host_groups = Hostgroup.all(:conditions => conditions, :joins => :puppetclasses, :select => 'DISTINCT hostgroups.id').map(&:id)
 
         opts = ''
diff --git a/app/models/concerns/taxonomix.rb b/app/models/concerns/taxonomix.rb
index cd4633074..1fee1c693 100644
--- a/app/models/concerns/taxonomix.rb
+++ b/app/models/concerns/taxonomix.rb
@@ -11,14 +11,56 @@ module Taxonomix
     after_initialize :set_current_taxonomy
 
     scoped_search :in => :locations, :on => :name, :rename => :location, :complete_value => true
+    scoped_search :in => :locations, :on => :id, :rename => :location_id, :complete_value => true
     scoped_search :in => :organizations, :on => :name, :rename => :organization, :complete_value => true
+    scoped_search :in => :organizations, :on => :id, :rename => :organization_id, :complete_value => true
   end
 
   module ClassMethods
 
+    attr_accessor :which_ancestry_method, :which_location, :which_organization
+
     # default inner_method includes children (subtree_ids)
     def with_taxonomy_scope(loc = Location.current, org = Organization.current, inner_method = :subtree_ids)
+      self.which_ancestry_method = inner_method
+      self.which_location        = loc
+      self.which_organization    = org
       scope =  block_given? ? yield : where('1=1')
+      scope = scope.where(:id => taxable_ids) if taxable_ids
+      scope.readonly(false)
+    end
+
+    # default inner_method includes parents (path_ids)
+    def with_taxonomy_scope_override(loc = nil, org = nil, inner_method = :path_ids)
+      # need to .unscoped or default_scope {with_taxonomy_scope} overrides inner_method
+      unscoped.with_taxonomy_scope(loc, org, inner_method)
+    end
+
+    def used_taxonomy_ids
+      used_location_ids + used_organization_ids
+    end
+
+    def used_location_ids
+      enforce_default
+      return [] unless which_location && SETTINGS[:locations_enabled]
+      (which_location.send(which_ancestry_method) + which_location.ancestor_ids).uniq
+    end
+
+    def used_organization_ids
+      enforce_default
+      return [] unless which_organization && SETTINGS[:organizations_enabled]
+      (which_organization.send(which_ancestry_method) + which_organization.ancestor_ids).uniq
+    end
+
+    # default scope is not called if we just use #scoped therefore we have to enforce quering
+    # to get correct default values
+    def enforce_default
+      if which_ancestry_method.nil?
+        self.scoped.limit(0).all
+      end
+    end
+
+    def taxable_ids(loc = which_location, org = which_organization, inner_method = which_ancestry_method)
       if SETTINGS[:locations_enabled] && loc
         inner_ids_loc = if Location.ignore?(self.to_s)
                           self.pluck(:id)
@@ -38,16 +80,10 @@ module Taxonomix
       inner_ids ||= inner_ids_org if inner_ids_org
       # In the case of users we want the taxonomy scope to get both the users of the taxonomy and admins.
       inner_ids << admin_ids if inner_ids && self == User
-      scope = scope.where(:id => inner_ids) if inner_ids
-      scope.readonly(false)
-    end
-
-    # default inner_method includes parents (path_ids)
-    def with_taxonomy_scope_override(loc = nil, org = nil, inner_method = :path_ids)
-      with_taxonomy_scope(loc, org, inner_method)
+      inner_ids
     end
 
-    def inner_select(taxonomy, inner_method)
+    def inner_select(taxonomy, inner_method = which_ancestry_method)
       # always include ancestor_ids in inner select
       taxonomy_ids = (taxonomy.send(inner_method) + taxonomy.ancestor_ids).uniq
       TaxableTaxonomy.where(:taxable_type => self.name, :taxonomy_id => taxonomy_ids).pluck(:taxable_id).compact.uniq
diff --git a/app/models/config_template.rb b/app/models/config_template.rb
index 53c9f0b5d..70a0d4be3 100644
--- a/app/models/config_template.rb
+++ b/app/models/config_template.rb
@@ -1,5 +1,5 @@
 class ConfigTemplate < ActiveRecord::Base
-  include Authorization
+  include Authorizable
   include Taxonomix
   audited :allow_mass_assignment => true
   self.auditing_enabled = !(File.basename($0) == "rake" && ARGV.include?("db:migrate"))
@@ -78,16 +78,6 @@ class ConfigTemplate < ActiveRecord::Base
     template.is_a?(ConfigTemplate) ? template : nil
   end
 
-  def enforce_permissions operation
-    # We get called again with the operation being set to create
-    return true if operation == "edit" and new_record?
-
-    return true if User.current and User.current.allowed_to?("#{operation}_templates".to_sym)
-
-    errors.add :base, (_("You do not have permission to %s this template") % operation)
-    false
-  end
-
   def self.build_pxe_default(renderer)
     if (proxies = SmartProxy.tftp_proxies).empty?
       error_msg = _("No TFTP proxies defined, can't continue")
diff --git a/app/models/domain.rb b/app/models/domain.rb
index 31034538a..8059e68fd 100644
--- a/app/models/domain.rb
+++ b/app/models/domain.rb
@@ -1,7 +1,7 @@
 require "resolv"
 # This models a DNS domain and so represents a site.
 class Domain < ActiveRecord::Base
-  include Authorization
+  include Authorizable
   include Taxonomix
   audited :allow_mass_assignment => true
 
@@ -40,25 +40,6 @@ class Domain < ActiveRecord::Base
     "#{id}-#{name.parameterize}"
   end
 
-  def enforce_permissions operation
-    # We get called again with the operation being set to create
-    return true if operation == "edit" and new_record?
-
-    current = User.current
-
-    if current.allowed_to?("#{operation}_domains".to_sym)
-      # If you can create domains then you can create them anywhere
-      return true if operation == "create"
-      # However if you are editing or destroying and you have a domain list then you are constrained
-      if current.domains.empty? or current.domains.map(&:id).include? self.id
-        return true
-      end
-    end
-
-    errors.add(:base, _("You do not have permission to %s this domain") % operation)
-    false
-  end
-
   # return the primary name server for our domain based on DNS lookup
   # it first searches for SOA record, if it failed it will search for NS records
   def nameservers
diff --git a/app/models/environment.rb b/app/models/environment.rb
index ec41bf330..9665dc382 100644
--- a/app/models/environment.rb
+++ b/app/models/environment.rb
@@ -1,6 +1,6 @@
 class Environment < ActiveRecord::Base
   include Taxonomix
-  include Authorization
+  include Authorizable
 
   before_destroy EnsureNotUsedBy.new(:hosts)
 
diff --git a/app/models/fact_value.rb b/app/models/fact_value.rb
index 410003e21..667c0bb3a 100644
--- a/app/models/fact_value.rb
+++ b/app/models/fact_value.rb
@@ -1,4 +1,5 @@
 class FactValue < ActiveRecord::Base
+  include Authorizable
 
   belongs_to_host
   belongs_to :fact_name
@@ -22,9 +23,8 @@ class FactValue < ActiveRecord::Base
             }
   scope :my_facts, lambda {
     unless User.current.admin? and Organization.current.nil? and Location.current.nil?
-      #TODO: Remove pluck after upgrade to newer rails as it would be
-      #done via INNER select automatically
-      where(:fact_values => {:host_id => Host.my_hosts.pluck(:id)})
+      host_ids = Host.authorized(:view_hosts, Host).select('hosts.id').all
+      where(:fact_values => {:host_id => host_ids})
     end
   }
 
diff --git a/app/models/filter.rb b/app/models/filter.rb
new file mode 100644
index 000000000..143b27674
--- /dev/null
+++ b/app/models/filter.rb
@@ -0,0 +1,138 @@
+class Filter < ActiveRecord::Base
+  include Taxonomix
+  include Authorizable
+
+  # tune up taxonomix for filters, we don't want to set current taxonomy
+  def self.add_current_organization?
+    false
+  end
+
+  def self.add_current_location?
+    false
+  end
+
+  attr_accessible :search, :resource_type, :permission_ids, :role_id, :unlimited,
+                  :organization_ids, :location_ids
+  attr_writer :resource_type
+  attr_accessor :unlimited
+
+  belongs_to :role
+  has_many :filterings, :dependent => :destroy
+  has_many :permissions, :through => :filterings
+
+  default_scope lambda { order(['role_id', "#{self.table_name}.id"]) }
+  scope :unlimited, lambda { where(:search => nil, :taxonomy_search => nil) }
+  scope :limited, lambda { where("search IS NOT NULL OR taxonomy_search IS NOT NULL") }
+
+  scoped_search :on => :search, :complete_value => true
+  scoped_search :on => :limited, :complete_value => { :true => true, :false => false }, :ext_method => :search_by_limited
+  scoped_search :on => :unlimited, :complete_value => { :true => true, :false => false }, :ext_method => :search_by_unlimited
+  scoped_search :in => :role, :on => :id, :rename => :role_id
+  scoped_search :in => :role, :on => :name, :rename => :role
+  scoped_search :in => :permissions, :on => :resource_type, :rename => :resource
+
+  before_validation :build_taxonomy_search, :nilify_empty_searches
+
+  validates :search, :presence => true, :unless => Proc.new { |o| o.search.nil? }
+  validates :role, :presence => true
+  validate :same_resource_type_permissions, :not_empty_permissions
+
+  def self.search_by_unlimited(key, operator, value)
+    search_by_limited(key, operator, value == 'true' ? 'false' : 'true')
+  end
+
+  def self.search_by_limited(key, operator, value)
+    value      = value == 'true'
+    value      = !value if operator == '<>'
+    conditions = value ? limited.where_values.join(' AND ') : unlimited.where_values.map(&:to_sql).join(' AND ')
+    { :conditions => conditions }
+  end
+
+  def self.get_resource_class(resource_type)
+    resource_type.constantize
+  rescue NameError => e
+    Rails.logger.debug "unknown klass #{resource_type}, ignoring"
+    return nil
+  end
+
+  def unlimited?
+    search.nil? && taxonomy_search.nil?
+  end
+
+  def limited?
+    !unlimited?
+  end
+
+  def to_s
+    _('filter for %s role') % self.role.try(:name) || 'unknown'
+  end
+
+  def resource_type
+    type = @resource_type || permissions.first.try(:resource_type)
+    type.blank? ? nil : type
+  end
+
+  def resource_class
+    @resource_class ||= self.class.get_resource_class(resource_type)
+  end
+
+  # We detect granularity by inclusion of Authorizable module and scoped_search definition
+  # we can define exceptions for resources with more complex hierarchy (e.g. Host is proxy module)
+  def granular?
+    @granular ||= begin
+      return false if resource_class.nil?
+      return true if resource_type == 'Host'
+      resource_class.included_modules.include?(Authorizable) && resource_class.respond_to?(:search_for)
+    end
+  end
+
+  def search_condition
+    searches = [self.search, self.taxonomy_search].compact
+    searches = searches.map { |s| parenthesize(s) } if searches.size > 1
+    searches.join(' and ')
+  end
+
+  private
+
+  def build_taxonomy_search
+    orgs = build_taxonomy_search_string('organization')
+    locs = build_taxonomy_search_string('location')
+
+    if self.organizations.empty? && self.locations.empty?
+      self.taxonomy_search = nil
+    else
+      taxonomies = [orgs, locs].reject {|t| t.blank? }
+      self.taxonomy_search = taxonomies.join(' and ')
+    end
+  end
+
+  def build_taxonomy_search_string(name)
+    relation = name.pluralize
+    taxes = self.send(relation).empty? ? [] : self.send(relation).map { |t| "#{name}_id = #{t.id}" }
+    taxes = taxes.join(' or ')
+    parenthesize(taxes)
+  end
+
+  def nilify_empty_searches
+    self.search = nil if self.search.empty? || self.unlimited == '1'
+    self.taxonomy_search = nil if self.taxonomy_search.empty?
+  end
+
+  def parenthesize(string)
+    if string.blank? || (string.start_with?('(') && string.end_with?(')'))
+      string
+    else
+      "(#{string})"
+    end
+  end
+
+  # if we have 0 types, empty validation will set error, we can't have more than one type
+  def same_resource_type_permissions
+    errors.add(:permissions, _('Permissions must be of same resource type')) if self.permissions.map(&:resource_type).uniq.size > 1
+  end
+
+  def not_empty_permissions
+    errors.add(:permissions, _('You must select at least one permission')) if self.permissions.blank? && self.filterings.blank?
+  end
+
+end
diff --git a/app/models/filtering.rb b/app/models/filtering.rb
new file mode 100644
index 000000000..59df77f2a
--- /dev/null
+++ b/app/models/filtering.rb
@@ -0,0 +1,6 @@
+class Filtering < ActiveRecord::Base
+  attr_accessible :filter_id, :permission_id
+
+  belongs_to :filter
+  belongs_to :permission
+end
diff --git a/app/models/host/base.rb b/app/models/host/base.rb
index 749c78a07..3cbf81919 100644
--- a/app/models/host/base.rb
+++ b/app/models/host/base.rb
@@ -3,6 +3,7 @@ require 'facts_parser'
 module Host
   class Base < ActiveRecord::Base
     include Foreman::STI
+    include Authorizable
     self.table_name = :hosts
     OWNER_TYPES = %w(User Usergroup)
 
@@ -20,42 +21,6 @@ module Host
                            :allow_blank => true,
                            :message     => (_("Owner type needs to be one of the following: %s") % OWNER_TYPES.join(', '))
 
-    scope :my_hosts, lambda {
-      user                 = User.current
-      return if user.admin? # Admin can see all hosts
-
-      owner_conditions             = sanitize_sql_for_conditions(["((hosts.owner_id in (?) AND hosts.owner_type = 'Usergroup') OR (hosts.owner_id = ? AND hosts.owner_type = 'User'))", user.my_usergroups.map(&:id), user.id])
-      domain_conditions            = sanitize_sql_for_conditions([" (hosts.domain_id in (?))",dms = (user.domain_ids)])
-      compute_resource_conditions  = sanitize_sql_for_conditions([" (hosts.compute_resource_id in (?))",(crs = user.compute_resource_ids)])
-      hostgroup_conditions         = sanitize_sql_for_conditions([" (hosts.hostgroup_id in (?))",(hgs = user.hostgroup_ids)])
-      organization_conditions      = sanitize_sql_for_conditions([" (hosts.organization_id in (?))",orgs = (user.organization_ids)])
-      location_conditions          = sanitize_sql_for_conditions([" (hosts.location_id in (?))",locs = (user.location_ids)])
-
-      fact_conditions = ""
-      for user_fact in (ufs = user.user_facts)
-        fact_conditions += sanitize_sql_for_conditions ["(hosts.id = fact_values.host_id and fact_values.fact_name_id = ? and fact_values.value #{user_fact.operator} ?)", user_fact.fact_name_id, user_fact.criteria]
-        fact_conditions = user_fact.andor == "and" ? "(#{fact_conditions}) and " : "#{fact_conditions} or  "
-      end
-      if (match = fact_conditions.match(/\A(.*).....\Z/))
-        fact_conditions = "(#{match[1]})"
-      end
-
-      conditions = ""
-      if user.filtering?
-        conditions  = "#{owner_conditions}"                                                                                                                                 if     user.filter_on_owner
-        (conditions = (user.domains_andor           == "and") ? "(#{conditions}) and #{domain_conditions} "           : "#{conditions} or #{domain_conditions} ")           unless dms.empty?
-        (conditions = (user.compute_resources_andor == "and") ? "(#{conditions}) and #{compute_resource_conditions} " : "#{conditions} or #{compute_resource_conditions} ") unless crs.empty?
-        (conditions = (user.hostgroups_andor        == "and") ? "(#{conditions}) and #{hostgroup_conditions} "        : "#{conditions} or #{hostgroup_conditions} ")        unless hgs.empty?
-        (conditions = (user.facts_andor             == "and") ? "(#{conditions}) and #{fact_conditions} "             : "#{conditions} or #{fact_conditions} ")             unless ufs.empty?
-        (conditions = (user.organizations_andor     == "and") ? "(#{conditions}) and #{organization_conditions} "     : "#{conditions} or #{organization_conditions} ")     unless orgs.empty?
-        (conditions = (user.locations_andor         == "and") ? "(#{conditions}) and #{location_conditions} "         : "#{conditions} or #{location_conditions} ")         unless locs.empty?
-        conditions.sub!(/\s*\(\)\s*/, "")
-        conditions.sub!(/\A(?:\(\))?\s?(?:and|or)\s*/, "")
-        conditions.sub!(/\(\s*(?:or|and)\s*\(/, "((")
-      end
-
-      joins(ufs.empty? ? nil : :fact_values).where(conditions)
-    }
     def self.attributes_protected_by_default
       super - [ inheritance_column ]
     end
diff --git a/app/models/host/managed.rb b/app/models/host/managed.rb
index 8b0a6e243..d6d454352 100644
--- a/app/models/host/managed.rb
+++ b/app/models/host/managed.rb
@@ -1,5 +1,4 @@
 class Host::Managed < Host::Base
-  include Authorization
   include ReportCommon
   include Hostext::Search
 
@@ -94,8 +93,6 @@ class Host::Managed < Host::Base
 
   scope :alerts_enabled, lambda { where(:enabled => true) }
 
-  scope :completer_scope, lambda { |opts| my_hosts }
-
   scope :run_distribution, lambda { |fromtime,totime|
     if fromtime.nil? or totime.nil?
       raise ::Foreman.Exception.new(N_("invalid time range"))
@@ -457,11 +454,13 @@ class Host::Managed < Host::Base
   # counts each association of a given host
   # e.g. how many hosts belongs to each os
   # returns sorted hash
-  def self.count_distribution assocication
+  def self.count_distribution association
     output = []
-    group(assocication).count.each do |k,v|
+    data = group("#{Host.table_name}.#{association}_id").reorder('').count
+    associations = association.to_s.camelize.constantize.where(:id => data.keys).all
+    data.each do |k,v|
       begin
-        output << {:label => k.to_label, :data => v }  unless v == 0
+        output << {:label => associations.detect {|a| a.id == k }.to_label, :data => v }  unless v == 0
       rescue
         logger.info "skipped #{k} as it has has no label"
       end
@@ -474,7 +473,7 @@ class Host::Managed < Host::Base
   # e.g. how many hosts belongs to each os
   # returns sorted hash
   def self.count_habtm association
-    counter = Host::Managed.joins(association.tableize.to_sym).group("#{association.tableize.to_sym}.id").count
+    counter = Host::Managed.joins(association.tableize.to_sym).group("#{association.tableize.to_sym}.id").reorder('').count
     #Puppetclass.find(counter.keys.compact)...
     association.camelize.constantize.find(counter.keys.compact).map {|i| {:label=>i.to_label, :data =>counter[i.id]}}
   end
@@ -489,28 +488,6 @@ class Host::Managed < Host::Base
     managed? and SETTINGS[:unattended] and capabilities.include?(:build) ? build == false : false
   end
 
-  def enforce_permissions operation
-    if operation == "edit" and new_record?
-      return true # We get called again with the operation being set to create
-    end
-    current = User.current
-    if (operation == "edit") or operation == "destroy"
-      if current.allowed_to?("#{operation}_hosts".to_sym)
-        return true if Host::Base.my_hosts.include? self
-      end
-    else # create
-      if current.allowed_to?(:create_hosts)
-        # We are unconstrained
-        return true if current.domains.empty? and current.hostgroups.empty?
-        # We are constrained and the constraint is matched
-        return true if (!current.domains.empty?    and current.domains.include?(domain)) or
-        (!current.hostgroups.empty? and current.hostgroups.include?(hostgroup))
-      end
-    end
-    errors.add(:base, _("You do not have permission to %s this host") % operation)
-    false
-  end
-
   def jumpstart?
     operatingsystem.family == "Solaris" and architecture.name =~/Sparc/i rescue false
   end
diff --git a/app/models/host_class.rb b/app/models/host_class.rb
index 6f9b881b6..a5bac8af3 100644
--- a/app/models/host_class.rb
+++ b/app/models/host_class.rb
@@ -1,5 +1,5 @@
 class HostClass < ActiveRecord::Base
-  include Authorization
+  include Authorizable
   audited :associated_with => :host, :allow_mass_assignment => true
   belongs_to_host :foreign_key => :host_id
   belongs_to :puppetclass
@@ -11,18 +11,4 @@ class HostClass < ActiveRecord::Base
     "#{host} - #{puppetclass}"
   end
 
-  private
-
-  def enforce_permissions operation
-    if operation == "edit" and new_record?
-      return true # We get called again with the operation being set to create
-    end
-    if User.current.allowed_to?(:edit_classes) && Host.my_hosts.pluck(:id).include?(self.host_id)
-      return true
-    else
-      errors.add(:base, _("You do not have permission to edit Puppet classes on this host"))
-      return false
-    end
-  end
-
 end
diff --git a/app/models/hostgroup.rb b/app/models/hostgroup.rb
index 8f492b921..8b72459be 100644
--- a/app/models/hostgroup.rb
+++ b/app/models/hostgroup.rb
@@ -1,5 +1,6 @@
 class Hostgroup < ActiveRecord::Base
-  include Authorization
+  has_ancestry :orphan_strategy => :restrict
+  include Authorizable
   include Taxonomix
   include HostCommon
   include NestedAncestryCommon
@@ -36,6 +37,7 @@ class Hostgroup < ActiveRecord::Base
   scoped_search :in => :hosts, :on => :name, :complete_value => :true, :rename => "host"
   scoped_search :in => :puppetclasses, :on => :name, :complete_value => true, :rename => :class, :operators => ['= ', '~ ']
   scoped_search :in => :environment, :on => :name, :complete_value => :true, :rename => :environment
+  scoped_search :on => :id, :complete_value => :true
   if SETTINGS[:unattended]
     scoped_search :in => :architecture, :on => :name, :complete_value => :true, :rename => :architecture
     scoped_search :in => :operatingsystem, :on => :name, :complete_value => true, :rename => :os
diff --git a/app/models/hostgroup_class.rb b/app/models/hostgroup_class.rb
index 1eb9d9af6..7c37cef56 100644
--- a/app/models/hostgroup_class.rb
+++ b/app/models/hostgroup_class.rb
@@ -1,5 +1,5 @@
 class HostgroupClass < ActiveRecord::Base
-  include Authorization
+  include Authorizable
   audited :associated_with => :hostgroup, :allow_mass_assignment => true
   belongs_to :hostgroup
   belongs_to :puppetclass
@@ -13,18 +13,4 @@ class HostgroupClass < ActiveRecord::Base
     "#{hostgroup} - #{puppetclass}"
   end
 
-  private
-
-  def enforce_permissions operation
-    if operation == "edit" and new_record?
-      return true # We get called again with the operation being set to create
-    end
-    if User.current.allowed_to?(:edit_classes) && Hostgroup.my_groups.pluck(:id).include?(self.hostgroup_id)
-      return true
-    else
-      errors.add(:base, _("You do not have permission to edit Puppet classes on this host group"))
-      return false
-    end
-  end
-
 end
diff --git a/app/models/image.rb b/app/models/image.rb
index cdee841c5..ee35ccfc3 100644
--- a/app/models/image.rb
+++ b/app/models/image.rb
@@ -1,4 +1,5 @@
 class Image < ActiveRecord::Base
+  include Authorizable
 
   audited :allow_mass_assignment => true
 
diff --git a/app/models/lookup_key.rb b/app/models/lookup_key.rb
index 843719f31..b3acb5a7f 100644
--- a/app/models/lookup_key.rb
+++ b/app/models/lookup_key.rb
@@ -1,5 +1,5 @@
 class LookupKey < ActiveRecord::Base
-  include Authorization
+  include Authorizable
 
   KEY_TYPES = %w( string boolean integer real array hash yaml json )
   VALIDATOR_TYPES = %w( regexp list )
diff --git a/app/models/lookup_value.rb b/app/models/lookup_value.rb
index 6c9028aa6..b39151d60 100644
--- a/app/models/lookup_value.rb
+++ b/app/models/lookup_value.rb
@@ -1,5 +1,5 @@
 class LookupValue < ActiveRecord::Base
-  include Authorization
+  include Authorizable
   belongs_to :lookup_key, :counter_cache => true
   validates :match, :presence => true, :uniqueness => {:scope => :lookup_key_id}
   delegate :key, :to => :lookup_key
@@ -69,24 +69,4 @@ class LookupValue < ActiveRecord::Base
     errors.add(:match, _("%{match} does not match an existing host group") % { :match => match }) and return false
   end
 
-  private
-
-  def enforce_permissions operation
-    # We get called again with the operation being set to create
-    return true if operation == "edit" and new_record?
-    allowed = case match
-      when /^fqdn=(.*)/
-        # check if current fqdn is in our allowed list
-        Host.my_hosts.where(:name => $1).exists? || self.host_or_hostgroup.try(:new_record?)
-      when /^hostgroup=(.*)/
-        # check if current hostgroup is in our allowed list
-        Hostgroup.my_groups.where(:title => $1).exists? || self.host_or_hostgroup.try(:new_record?)
-      else
-        false
-    end
-    return true if allowed
-    errors.add :base, _("You do not have permission to %s this Smart Variable") % operation
-    return false
-  end
-
 end
